/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *   Mupen64plus - sram.h                                                  *
 *   Mupen64Plus homepage: http://code.google.com/p/mupen64plus/           *
 *   Copyright (C) 2014 Bobby Smiles                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef M64P_PI_SRAM_H
#define M64P_PI_SRAM_H

#include <stdint.h>

struct pi_controller;

enum { SRAM_SIZE = 0x8000 };

struct sram
{
   /* external sram storage */
   void* user_data;
   void (*save)(void*);
   uint8_t* data;
};

void init_sram(struct sram* sram, void* user_data, void (*save)(void*), uint8_t* data);

void sram_save(struct sram* sram);

void format_sram(uint8_t* sram);

void dma_write_sram(struct pi_controller* pi);
void dma_read_sram(struct pi_controller* pi);

#endif
